/* 
 * This widget is based on Durvivors Redbox widget for the Mac OSX
 * dashboard widget.  The original idea for the Flip functionality and
 * the close button on the widget comes from SioSAE's Dashboard Weather
 * widget and has been implemented with permission by SioSAE.
 * 
 * Copyright  2005 by Jaime R. Wilkesheski aka Durvivor and Thomas Mittag aka highnoon
 *
 * Permission to use, copy, modify and distribute this software and its documentation for any purpose and without fee is hereby granted, provided that the above copyright notice appear in all copies and that both the copyright notice and this permission notice appear in supporting documentation.  Jaime R. Wilkesheski aka Durvivor makes no representations about the suitability of this software for any purpose. It is provided "as is" without express or implied warranty.
 * 
 * JAIME R. WILKESHESKI AKA DURVIVOR DISCLAIMS ALL WARRANTIES WITH REGARD TO THIS SOFTWARE, INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL JAIME R. WILKESHESKI AKA DURVIVOR BE LIABLE FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

var fireFoxTest=false;
var markets;
var myURL;
var flip2BackSide = true;
var flipState =0;
var startStampToo;
var flippingNumber=1;
var container = new Array;
var codeLinks = new Array;
var container2 = new Array;
var nextIndex = 0;
var hOffsets = new Array;
var startStampThree;
var fadeOut;
var focusState;
var flip;
var container3 = new Array;
var container4 = new Array;
var startingY = 44;
var currentCodes = 0;
var enableMore = false;

// Global Variable that contains the page we are scraping
var req;

var testMkt="<xml?>";

var message="<MESSAGE>Hi</MESSAGE>";

var testMkt1="<MARKET><NAME>Denver</NAME><CODELIST><CODE><CODETEXT>ABCDEF</CODETEXT><DESCRIPTION>Shorter</DESCRIPTION><WEBSITE>  </WEBSITE><OTHER>  </OTHER></CODE><CODE><CODETEXT>FLYFISH</CODETEXT>	<DESCRIPTION>Are you a fisherman, Your gonna love this code get a mcfillet & rent a movie</DESCRIPTION><WEBSITE>FlyFisher.com</WEBSITE><OTHER>  </OTHER></CODE>";

var testMkt1a="<CODE><CODETEXT>SALLY</CODETEXT><DESCRIPTION>Sally</DESCRIPTION><WEBSITE>  </WEBSITE><OTHER>  </OTHER></CODE><CODE><CODETEXT>DAY</CODETEXT>	<DESCRIPTION>Daylicious</DESCRIPTION><WEBSITE>FlyFisher.com</WEBSITE><OTHER>  </OTHER></CODE>";

var testMkt12="<CODE><CODETEXT>CRAZY</CODETEXT><DESCRIPTION>Crazy</DESCRIPTION><WEBSITE>  </WEBSITE><OTHER>  </OTHER></CODE>";

var testMkt1b="<CODE><CODETEXT>UNited</CODETEXT><DESCRIPTION>United</DESCRIPTION><WEBSITE>  </WEBSITE><OTHER>  </OTHER></CODE><CODE><CODETEXT>Northwest</CODETEXT>	<DESCRIPTION>Daylicious</DESCRIPTION><WEBSITE>FlyFisher.com</WEBSITE><OTHER>  </OTHER></CODE></CODELIST></MARKET>";

var testMkt2="<MARKET><NAME>St. Louis</NAME><CODELIST><CODE><CODETEXT></CODETEXT><DESCRIPTION>Starting November 29th, purchase the CARDINALS Busch Stadium Commemorative DVD for $17.99 exclusively at redbox.</DESCRIPTION><WEBSITE>http://www.redbox.com/Offers/index.cfm</WEBSITE><OTHER></OTHER></CODE></CODELIST></MARKET>";

var testMkt3="<MARKET><NAME>Huston</NAME><CODELIST><CODE><CODETEXT>HOS</CODETEXT><DESCRIPTION>Go Huston.</DESCRIPTION><WEBSITE>http://www.redbox.com/Offers/index.cfm</WEBSITE><OTHER></OTHER></CODE></CODELIST></MARKET>";

var testMkt4="<MARKET><NAME>Las Vegas</NAME><CODELIST><CODE><CODETEXT>LIGHTS</CODETEXT><DESCRIPTION>Shinging Lights of Vegas are worth a free movie..</DESCRIPTION><WEBSITE>http://www.redbox.com/Offers/index.cfm</WEBSITE><OTHER></OTHER></CODE></CODELIST></MARKET>";


var testData = testMkt + message + testMkt3 + testMkt1 + testMkt1a + testMkt12 + testMkt1b + testMkt2 + testMkt4 ;


function initWidget()
{
	// set the refreshTimer...
	refreshTimer.interval = preferences.refreshFrequency.value * 3600;
	refreshTimer.ticking = true;
	container[0] = code1;
	container[1] = code2;
	container[2] = code3;
	container2[0] = weblink1;
	container2[1] = weblink2;
	container2[2] = weblink3;
	container3[0] = button1;
	container3[1] = button2;
	container3[2] = button3;
	container4[0] = open1;
	container4[1] = open2;
	container4[2] = open3;
	hOffsets[0]= 104;
	hOffsets[1]= 144;
	hOffsets[2]= 214;
    widgetGo();
}

function initMarketPref()
{
	marketName.data = preferences.rbMktPref.value;
	marketSelect.data = preferences.rbMktPref.value;
}


function widgetGo()
{
   if ( !fireFoxTest )
   {
      loadXMLDoc("http://homepage.mac.com/durvivor/redboxcodes/rbc_2.xml");
   }
   else
   {
      processResponse();
   }
}

function widgetGoAlt( alturl )
{
   clearCodes();
   if ( !fireFoxTest )
   {
      loadXMLDoc( alturl );
   }
   else
   {
      processResponse();
   }
}

function loadXMLDoc(url) 
{
    myURL = new URL();
    myURL.location = url;
    print(url);
	req = myURL.fetch();
	print("the result was: " + myURL.response);
    processReqChange();
}

function processReqChange() 
{
    if (myURL.response != 0) {
	       var strAltURL = getAltURL( req );
           if ( strAltURL.length > 0 &&
                strAltURL.indexOf("ttp://") > 0 )
           {
	            print ("going to redirect to " + strAltURL);
                widgetGoAlt( strAltURL );
           }
           else
           {
               processResponse();
           }
    }
}


function getMarketName( text )
{
      var start = text.indexOf("<NAME>") ;
      var   end = text.indexOf("</NAME>"); 
      var name = text.substring(start+6,end);
      return name;
}

function parseMarkets( text )
{
   // First find a city..
   if ( text.indexOf("<MARKET>") >= 0 )
   {
      var start = text.indexOf("<MARKET>") ;
      var   end = text.indexOf("</MARKET>"); 
      markets[markets.length]=text.substring(start+8,end);
      var remainingText = text.substring(end+8,text.length);
      parseMarkets( remainingText );
   }
}

var codes = new Array();
function parseCodes( text )
{
   // First find the codes..
   if ( text.indexOf("<CODE>") >= 0 )
   {
      var start = text.indexOf("<CODE>") ;
      var   end = text.indexOf("</CODE>");
      var code = text.substring(start+6, end);
      if( getCodeText(code) != "" )
      {
          codes[codes.length]=code;
      }
      var remainingText = text.substring(end+6,text.length);
      parseCodes( remainingText );
   }
}

function getXMLForMarket( market )
{
   var returnXML="";

   for ( var i = 0 ; i < markets.length ; i++ )
   {
      if ( getMarketName(markets[i]) == market )
      {
         returnXML=markets[i];
      }
   }
   return returnXML;
}

var mSelectedMarket="Denver";
function changeMarket()
{
   var marketSelect = document.getElementById("markets");
   var selectedMarket = marketSelect.selectedIndex ;
   mSelectedMarket = marketSelect.options[selectedMarket].value 
   document.getElementById("marketName").innerHTML=mSelectedMarket;
   if ( window.widget )
   {
      widget.setPreferenceForKey(mSelectedMarket, "rbMktPref");
   }
   displayCodes( 0 );
}

var displayedCodes;
function displayCodes( iStartCode )
{
   mSelectedMarket = preferences.rbMktPref.value;
   marketName.data = mSelectedMarket;
   var iCount=0;
   description.data = "";
	
   var marketXML=getXMLForMarket( mSelectedMarket );
   codes = new Array();
   parseCodes( marketXML );

   var strDisplay="";
   fadeCodes(false);      

   if ( codes.length > 0 )
   {
      displayedCodes = new Array();
      if ( iStartCode+3 > codes.length ) 
      { 
         iCount=codes.length-iStartCode; 
      }
      else 
      { 
         iCount=3; 
      }
      
      for ( var j = 0; j < 3; j++)
      {
	      container[j].data = "";
	      container2[j].opacity = 0;
	      container3[j].opacity = 0;
	      container4[j].opacity = 0;
      }
      
      var lastOffset = 42;
      for ( var i = 0 ; i < iCount ; i++ )
      {
	     var curIndex = i;
         var strWebsite=getWebsite(codes[i+iStartCode]);
	     print (strWebsite);
         if ( strWebsite.length > 0 &&  
              strWebsite.indexOf("ttp://") > 0 )
         {
	         codeLinks[curIndex] = strWebsite;
         }
         else
         {
	         codeLinks[curIndex] = "";
         }
         
         container[curIndex].data = getCodeText(codes[i+iStartCode]);
         var myWidth = container[curIndex].width;
         container2[curIndex].hOffset = 164 - myWidth/2 - 14;
         displayedCodes[displayedCodes.length]=getCodeText(codes[i+iStartCode]); 
      }
      
      if ( codes.length > 3 ) //-iStartCode > 3 )
      {
	      enableMore = true;
          if ( (codes.length-iStartCode)>3 )
          {
              nextIndex = iStartCode+3;
          }
          else
          {
	          nextIndex = 0;
          }
       }
       else
       {
	       enableMore = false;
       }
   }
   else
   {
	   description.data = "Sorry, no codes at this time";
	   description.vOffset = 70;
	   description.opacity = 255;
	   description.size = 10;
   }
   
   if( iCount != currentCodes )
   {
       doAnimateMove(iCount);
   }
   else
   {
	   fadeCodes(true);
   }
}

function highlightCode( code )
{
   for ( var i=0 ; i < 3 ; i++ )
   {
	   if( i == code )
	   {
		   container[i].color = "#ecc14c";
	   }
	   else
	   {
		   container[i].color = "#ffffff";
	   }
   }
   displayCodeInfo( code );
}
      



function displayCodeInfo( code )
{
   var codeXML = getXMLForCode( container[code].data );

   var strDesc="";
   strDesc+=getCodeDescription(codeXML);

   print ( strDesc );
   if ( strDesc.length > 140 )
      description.size = 9;
   else
      description.size = 10;
   
   description.data = strDesc;
}

function getXMLForCode( code )
{
   var returnXML="";

   for ( var i = 0 ; i < codes.length ; i++ )
   {
      if ( getCodeText(codes[i]) == code )
      {
         returnXML=codes[i];
      }
   }
   return returnXML;
}

function getCodeText( text )
{
      var start = text.indexOf("<CODETEXT>") ;
      var   end = text.indexOf("</CODETEXT>"); 
      var codeText = text.substring(start+10,end);
      return codeText;
}

function getWebsite( text )
{
      var start = text.indexOf("<WEBSITE>") ;
      var   end = text.indexOf("</WEBSITE>"); 
      var codeText = text.substring(start+9,end);
      return codeText;
}

var strMsgLink = "";
function getMessage( text )
{
      strMessage="";
      var start = text.indexOf("<YWE_MSG>") ;
      var   end = text.indexOf("</YWE_MSG>"); 
      var strMessage = text.substring(start+9,end);
      
      // now look for the link if there is any.
      start = text.indexOf("<YWE_MSG_LINK>") ;
      end = text.indexOf("</YWE_MSG_LINK>"); 
      strMsgLink = text.substring(start+14,end);
      print(strMsgLink);
      return strMessage ;
}

function getCodeDescription( text )
{
      var start = text.indexOf("<DESCRIPTION>") ;
      var   end = text.indexOf("</DESCRIPTION>"); 
      var descText = text.substring(start+13,end);
      //strip leading and trailing whitespace.
      descText = descText.replace(/^\s+|\s+$/g, "");
      print ("Desc: " + descText);
      return descText;
}

function processResponse()
{
   initMarketPref();

   // We should only get here when we have results 
   var text="";

   if ( !fireFoxTest )
   {
	   var text = req;
	   print(text);
   }
   else
   {
      text=testData;
   }


   helpUs.data = getMessage(text);
   markets = new Array();
   parseMarkets(text);
   print ("parse markets done!");
   populateMarkets();
   if ( changeToMktPref() )
   {
      displayCodes(0);
   }
}


function getAltURL( text )
{
	print ("getting Alternate URL");
      strAltURL="";
      var start = text.indexOf("<ALTURL>") ;
      var   end = text.indexOf("</ALTURL>"); 
      var strAltURL = text.substring(start+8,end);
      print ("ALT URL is: " + strAltURL);
      return strAltURL ;
}

function clearCodes()
{
	code1.data = code2.data = code3.data = "";
	marketName.data = "";
	description.data = "Accessing Free Movie Codes...";
}

function changeToMktPref()
{
    var rbMktPref = preferences.rbMktPref.value;
    if ( rbMktPref == "none" )
    {
        clearCodes();
        description.data = "Click on the      to choose your city. ";
        description.vOffset = 70;
        description.size = 9;
        description.opacity = 255;
        infoHint.opacity = 255;
        return false;
    }
    else
    {
        var found = false;
         
        for ( var i = 0 ; i < markets.length ; i++ )
        {
            if ( rbMktPref == getMarketName(markets[i]) )
            {
	            infoHint.opacity = 0;
                found = true;
            }
        }     
             
        if ( !found )
        {
        	clearCodes();
        	description.data = "Click on the      to choose your city. ";
        	description.vOffset = 70;
        	description.opacity = 255;
        	description.size = 9;
        	infoHint.opacity = 255;
        	return false;
        }
        else 
        {
            return true;
        }
    }
}

function populateMarkets()
{
//   var marketSelect; //document.getElementById("markets");
//   marketSelect.length = 0;

//   for ( var i = 0 ; i < markets.length ; i++ )
//   {
//      marketSelect.options[marketSelect.length] = 
//          new Option( getMarketName(markets[i]), 
//                      getMarketName(markets[i]) );
//   }

}

function marketDialog()
{
	var formfields = Array();
	var Options = Array();
	
	formfields[0] = new FormField();
	formfields[0].name = 'markets';
	formfields[0].type = 'popup';
	formfields[0].title = 'Redbox Market:';
	formfields[0].defaultValue = marketName.data;
	
	Options[0] = 'none';
    formfields[0].description = 'You can choose one of the available markets for the Redbox codes'; 
	for ( var i = 0 ; i < markets.length ; i++ )
    {
	    Options[Options.length] = getMarketName(markets[i]);
    }
    formfields[0].option = Options;
    formResults = form(formfields, 'Select Redbox Market', 'Set Market');
    print (formfields[0].option);
    print (formResults);
    
    if( formResults != null )
    {
	    preferences.rbMktPref.value = formResults;
	    marketName.data = formResults;
	    marketSelect.data = formResults;
    }
}

/*
 * Acknowledgment:
 * The main idea and original implementation of the flip functionality
 * is SioSAE's work and has been used with the authors permission.
 * The code has been partially altered from the original implementation.
 */
function doFlipFade(duration)
{
	rightNowToo =  new Date();
	if (!startStampToo) startStampToo = rightNowToo.getTime();
	time 	= (checkLimit(rightNowToo.getTime() - startStampToo, 0, duration));
	percent	= time/duration;
	info.opacity = infoRollie.opacity = 0;
	
	if (time >= duration)
	{
		doFlipFadeAnimation.ticking = false;
		startStampToo = null;

		if(flip2BackSide)
		{
			marketName.opacity = 0;
			description.opacity = 0;
			infoHint.opacity = 0;
		}
		else
		{
			marketSelect.opacity = 0;
			cityLabel.opacity = 0;
			versionLabel.opacity = 0;
			durvivor.opacity = 0;
			helpUs.opacity = 0;
		}
		
		var flip = new CustomAnimation(7, doFlip);
		flip.image = 18;
		flip.direction = -1;
		
		if( flip2BackSide )
		{
		   flip.image = 1;
		   flip.direction = 1;
	    }
	    
	    animator.runUntilDone(flip);
	}
	else
	{
	percent = Math.sin( percent * (Math.PI/2) );

	if (!flip2BackSide)
	{
		theFinalNumber = 255 - Math.round(percent * 255);
		marketSelect.opacity = theFinalNumber;
		helpUs.opacity = theFinalNumber;
    }
    else
    {
	    theFinalNumber = 255 - Math.round(percent * 255);
		marketName.opacity = theFinalNumber;
		
		if( description.opacity > 0 )
		    description.opacity = theFinalNumber;
				    
		if( infoHint.opacity > 0 )
		    infoHint.opacity = theFinalNumber;
    }
   }
}

function doFlip()
{
	flippingImage.hOffset = 14;
	flippingImage.vOffset = 0;
    var imageNumber = this.image;
    this.image = imageNumber + this.direction;
    print("flip image: "+imageNumber);
    if(!flip2BackSide)
	{
		if(imageNumber==18)
  	        backSide.opacity = done.opacity = 0;
   	}
    else
	{
	    if(imageNumber==1)
			top.opacity = middle.opacity = bottom.opacity = RedBox.opacity = 0;
	}
	
	if( imageNumber < 10 && imageNumber > 0 )
	{
		flippingImage.src = "flip/front" + imageNumber + ".png";
        flippingImage.opacity = 255;
		return true;
	}
	else if (imageNumber < 19 && imageNumber > 0 )
	{
		flippingImage.src = "flip/prefs" + imageNumber + ".png";
        flippingImage.opacity = 255;
		return true;
	}
	else
	{
		flippingImage.opacity = 0;
		
		if( flip2BackSide )
		{
   		    print("end of flip - back side");
			flip2BackSide = false;
			backSide.opacity = done.opacity = helpUs.opacity = durvivor.opacity = 255;
			marketSelect.opacity = cityLabel.opacity = versionLabel.opacity = 255;
		}
		else
		{
   		    print("end of flip - front side");
			flip2BackSide = true;
			top.opacity = middle.opacity = bottom.opacity = RedBox.opacity = 255;
			info.opacity = 100;
			infoRollie.opacity = 1;
   		    marketName.opacity = 255;
		    if( changeToMktPref() )
		    {
			    displayCodes(0);
		    }
		}
		return false;
	}
}

function checkLimit(a, b, c)
{
    //print("checkLimit");
	return a < b ? b : (a > c ? c : a);
}

function wrapURL(theURL)
{
   openURL(theURL);
}

function doAnimateMove(iCount)
{
	var y1 = startingY;
	var y2;
	
	if( iCount == 0 )
	{
		y2 = startingY = 44;
		fadeCodes(false);
	}
	else
	{
		y2 = startingY = 44 + iCount*20 - 10;
	}
	
	var ExpandMiddle = new CustomAnimation(1, updateMiddle);
	ExpandMiddle.duration = 200;
	ExpandMiddle.startY = y1;
	ExpandMiddle.endY = y2;
	ExpandMiddle.startTime = animator.milliseconds;
	ExpandMiddle.ease = animator.kEaseInOut;
	
	animator.runUntilDone(ExpandMiddle);
	currentCodes = iCount;
	fadeCodes(true);
}

function fadeCodes(fadeIn)
{
	print("fading codes now!");
	var fadeButtons = new CustomAnimation(1, updateButtons);
	fadeButtons.duration = 150;
	fadeButtons.fadeIn = fadeIn;
	fadeButtons.startTime = animator.milliseconds;
	
	animator.runUntilDone(fadeButtons);
}

function updateButtons()
{
   var now = animator.milliseconds;	
   var t = checkLimit( now - this.startTime, 0, this.duration);
   var percent = t / this.duration;
   var easeType;
   var startOpacity;
   var endOpacity;
   print( "fading...");
   if(this.fadeIn == true)
   {
	   easeType = animator.kEaseIn;
	   startOpacity = 0;
	   endOpacity = 255;
   }
   else
   {
	   easeType = animator.kEaseOut;
	   startOpacity = 255;
	   endOpacity = 0;
   }
   
   var opacity = animator.ease(startOpacity, endOpacity, percent, easeType);
   for( var i = 0; i<currentCodes; i++)
   {
	   container[i].opacity = opacity;
	   if( codeLinks[i] != "" )
	       container2[i].opacity = opacity;
	   container3[i].opacity = opacity;
	   container4[i].opacity = opacity;
   }

   if( enableMore == true )
   		moreBtn.opacity = opacity;
   		
   if( animator.milliseconds >= (this.startTime + this.duration))
   {
	   	for( var i = 0; i<currentCodes; i++)
   	   	{
	   		container[i].opacity = endOpacity;
	   		if( codeLinks[i] != "" )
	   		    container2[i].opacity = endOpacity;
	   		container3[i].opacity = endOpacity;
	   		container4[i].opacity = endOpacity;
   		}
   		
   	    if( enableMore )
   	    	moreBtn.opacity = endOpacity;
   	    	
   		if( this.fadeIn == false )
   		{
	   		enableMore = false;
   		}
   		
	   	return false;
   	}
   	
   	return true;
}

function updateMiddle()
{
   var now = animator.milliseconds;	
   var t = checkLimit( now - this.startTime, 0, this.duration);
   var percent = t / this.duration;
   
   var delta = animator.ease(this.startY, this.endY, percent, this.ease);
   print(delta);
   bottom.vOffset = 38 + delta;
   info.vOffset = 34 + delta;
   infoRollie.vOffset = 34 + delta;
   expander.vOffset = 36 + delta;
   middle.height = delta;
   moreBtn.vOffset = 32 + delta;
   
   if( animator.milliseconds >= (this.startTime + this.duration))
   {
	   print("exit expand!");
	   if( flipState == 0 )
	   {
	      flipState = 1;
	   }
	   else
	   { 
	      flipState = 0;
       }   
	   return false;
   }
   return true;
}

function ExpandButton(CodeIndex, Expand)
{
	var newHeight;
	var offset = container3[CodeIndex].vOffset;
	
	if( Expand == true )
	{
//		play("open.mp3");
		displayCodeInfo(CodeIndex); 
		newHeight = description.height + 10;
		// position the description
		description.vOffset = container[CodeIndex].vOffset + 8;
		btnTop.vOffset = offset;
		btnMiddle.vOffset = offset + 10;
		btnBottom.vOffset = offset + 14;
		
		// now hide the original button and replace with parts.
		container3[CodeIndex].opacity = 0;
		btnTop.opacity = btnMiddle.opacity = btnBottom.opacity = 255;
		
		var expandBtn = new CustomAnimation(1, UpdateExpand);
		expandBtn.duration = 200;
		expandBtn.startRot = 360;
		expandBtn.endRot = 225;
		expandBtn.startY = 4;
		expandBtn.endY = newHeight;
		expandBtn.btnIndex = CodeIndex;
		expandBtn.startTime = animator.milliseconds;
	    expandBtn.ease = animator.kEaseInOut;
		
		animator.runUntilDone(expandBtn);
		
		var fadeDesc = new FadeAnimation(description, 255, 150, animator.kEaseIn);
		animator.runUntilDone(fadeDesc);
	}
	else
	{
		var fadeDesc = new FadeAnimation(description, 0, 150, animator.kEaseOut);
		animator.runUntilDone(fadeDesc);
		 
		var expandBtn = new CustomAnimation(1, UpdateExpand);
		newHeight = description.height + 10;
		expandBtn.duration = 200;
		expandBtn.startRot = 225;
		expandBtn.endRot = 360;
		expandBtn.startY = newHeight;
		expandBtn.endY = 4;
		expandBtn.btnIndex = CodeIndex;
		expandBtn.startTime = animator.milliseconds;
	    expandBtn.ease = animator.kEaseInOut;

	    animator.runUntilDone(expandBtn);

	    container3[CodeIndex].opacity = 255;
		btnTop.opacity = btnMiddle.opacity = btnBottom.opacity = 0;
//		play("close.mp3");
	} 
}

function UpdateExpand()
{
	print("expandButton");
   var now = animator.milliseconds;	
   var t = checkLimit( now - this.startTime, 0, this.duration);
   var percent = t / this.duration;
   
   var delta = animator.ease(this.startY, this.endY, percent, this.ease);
   var delta1 = animator.ease(this.startRot, this.endRot, percent, this.ease);
   bottom.vOffset = startingY + delta + 34;
   info.vOffset = startingY + delta + 30;
   infoRollie.vOffset = startingY + delta + 30;
   expander.vOffset = startingY + delta + 32;
   middle.height = startingY + delta - 4;
   moreBtn.vOffset = startingY + delta + 28;
   btnMiddle.height = delta;
   btnBottom.vOffset = container3[this.btnIndex].vOffset + 10 + delta;
   container4[this.btnIndex].rotation = delta1;
   for(var i=this.btnIndex+1; i<currentCodes; i++)
   {
	   var curIndex = i - this.btnIndex;
	   container3[i].vOffset = container3[this.btnIndex].vOffset + 20 * curIndex + delta - 4;
	   container[i].vOffset = container[this.btnIndex].vOffset + 20 * curIndex + delta - 4;
	   container2[i].vOffset = container2[this.btnIndex].vOffset + 20 * curIndex + delta - 4;
	   container4[i].vOffset = container4[this.btnIndex].vOffset + 20 * curIndex + delta - 4;
   }
   
   if( animator.milliseconds >= (this.startTime + this.duration))
   {
	   print("exit expand button!");
	   return false;
   }
   return true;
}

initWidget();